/*
 * Copyright (c) 2004 Virtual Worlds Productions
 * Email: virtual_worlds@gmx.de
 *
 * This program is free software; you can redistribute it and/or modify  it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option) any
 * later version.
 *
 * Please contact virtual_worlds@gmx.de if you are interested in a source
 * package which is not licensed under the GPL
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. VIRTUAL WORLDS PRODUCTIONS AND ITS
 * LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES.
 * IN NO EVENT WILL VIRTUAL WORLDS PRODUCTIONS OR ITS LICENSORS BE LIABLE FOR
 * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
 * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS
 * OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
 * SOFTWARE, EVEN IF VIRTUAL WORLDS PRODUCTIONS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import javax.swing.*;
import java.awt.event.*;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Universe extends Applet
   {
   private SimpleUniverse u = null;
   private TransformGroup    BoxTG=new TransformGroup();
   private Transform3D       BoxT3D=new Transform3D();
   private javax.swing.Timer RotTimer;
   SymAction                 AListener=new SymAction();
   private int               ActAngle=0;

   public Universe()
      {
      }

   public BranchGroup createSceneGraph()
      {
      BranchGroup      RootBG=new BranchGroup();
      Appearance       BoxAppearance=new Appearance();

      PointLight       PLgt=new PointLight(new Color3f(1f,0f,0f),new Point3f(-2f,0f,0f),new Point3f(0f,0.25f,0f));
      SpotLight        SLgt=new SpotLight(new Color3f(0f,1f,0f),new Point3f(5.75f,-1f,-8.9f),new Point3f(0f,0f,0f),new Vector3f(-1f,0f,0f),(float)Math.toRadians(25),7f);

      AmbientLight     ALgt=new AmbientLight(new Color3f(0.3f,0.3f,0.3f));
      BoundingSphere   BigBounds=new BoundingSphere(new Point3d(),100000);
      ALgt.setInfluencingBounds(BigBounds);
      BoxT3D.setTranslation(new Vector3f(0f,0f,-8f));
      BoxT3D.setRotation(new AxisAngle4f(1f,0f,1f,(float)Math.toRadians(-60)));
      BoxTG.setTransform(BoxT3D);
      BoxAppearance.setMaterial(new Material(new Color3f(0.5f,0.5f,0.5f),new Color3f(0f,0f,0f),new Color3f(0.9f,0.9f,0.9f),new Color3f(0.8f,0.8f,0.8f),1f));
      BoxTG.addChild(new com.sun.j3d.utils.geometry.Box(1f,2f,3f,Sphere.GENERATE_NORMALS,BoxAppearance));

      BoxTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
      RootBG.addChild(BoxTG);

      PLgt.setInfluencingBounds(BigBounds);
      RootBG.addChild(PLgt);
      SLgt.setInfluencingBounds(BigBounds);
      RootBG.addChild(SLgt);
      RootBG.addChild(ALgt);
      RootBG.compile();
      return RootBG;
      }



   void handleTimer()
      {
      Transform3D tempT3D=new Transform3D();

      ActAngle+=1;
      if (ActAngle>=360) ActAngle-=360;
      BoxT3D.setRotation(new AxisAngle4f(1f,0f,1f,(float)Math.toRadians(-60)));
      tempT3D.rotY(Math.toRadians(ActAngle));
      BoxT3D.mul(tempT3D);
      BoxTG.setTransform(BoxT3D);
      }



   public void init()
      {
	   setLayout(new BorderLayout());
      GraphicsConfiguration config=SimpleUniverse.getPreferredConfiguration();
      Canvas3D c = new Canvas3D(config);
	   add("Center", c);
      u = new SimpleUniverse(c);

      u.getViewingPlatform().setNominalViewingTransform();
   	u.addBranchGraph(createSceneGraph());
      RotTimer=new javax.swing.Timer(50,AListener);
      RotTimer.start();
      }



   public void destroy()
      {
//	   u.cleanup();
      }

   public static void main(String[] args)
      {
	   new MainFrame(new Universe(), 400, 400);
      }



   class SymAction implements ActionListener
      {
      public void actionPerformed(ActionEvent e)
         {
         handleTimer();
         }
      }


}
